# SPDX-FileCopyrightText: Copyright (c) 2024, Linaro Limited.
#
# SPDX-FileCopyrightText: <text>Copyright 2022-2024 Arm Limited and/or its
# affiliates <open-source-office@arm.com></text>
#
# SPDX-License-Identifier: MIT
---

{% set should_run = ('nightly' in FREQUENCY or 'weekly' in FREQUENCY or 'all' in FORCE_TESTS or 'ptest' in FORCE_TESTS.split(',')) %}

device_type: n1sdp
job_name: {{ CI_JOB_NAME }}
timeouts:
  job:
{% if should_run %}
    minutes: 1130
{% else %}
    minutes: 100
{% endif %}

{%- if FREQUENCY == 'adhoc' %}
priority: medium
{%- else %}
priority: low
{%- endif %}
visibility:
  group:
    - cassini

metadata:
  source: {{ CI_PROJECT_URL }}
  path: .gitlab/lava/n1sdp/ptest.yml.j2
  gitlab-job-url: {{ CI_JOB_URL }}

notify:
  criteria:
    status: finished
  callbacks:
    - url: "{{ CI_API_V4_URL }}/projects/{{ CI_PROJECT_ID }}/jobs/{{ TEST_COMPLETE_JOB_ID }}/play"
      method: POST
      token: "{{ LAVA_CALLBACK_TOKEN }}"
      header: "PRIVATE-TOKEN"
      dataset: minimal

context:
  extra_nfsroot_args: ',vers=3'
  extra_kernel_args: rootwait

actions:

#
# Deploy a firmware bundle with the customized "uefi.bin" installed. This
# enables an EFI network driver, allowing us to TFTP boot from GRUB.
#
- deploy:
    namespace: recovery
    timeout:
      minutes: 5
    failure_retry: 2
    to: flasher
    images:
      recovery_image:
        url: {{ LAVA_STATIC_FILES_SERVER_URL }}/n1sdp/4/n1sdp-board-firmware-force-netboot.zip
        compression: zip

- deploy:
    namespace: debian
    timeout:
      minutes: 10
    failure_retry: 2
    to: tftp
    os: debian
    kernel:
      url: {{ LAVA_STATIC_FILES_SERVER_URL }}/n1sdp/4/debian/linux
      type: image
    ramdisk:
      url: {{ LAVA_STATIC_FILES_SERVER_URL }}/n1sdp/4/debian/ramdisk.img
    nfsrootfs:
      url: {{ LAVA_STATIC_FILES_SERVER_URL }}/n1sdp/4/debian/debian-buster-arm64-rootfs.tar.xz
      compression: xz

- boot:
    namespace: recovery
    timeout:
      minutes: 5
    method: minimal
    parameters:
      kernel-start-message: ''
    prompts: ['Cmd>']

- boot:
    namespace: uart1
    method: new_connection
    connection: uart1

- boot:
    namespace: uart3
    method: new_connection
    connection: uart3

- boot:
    namespace: debian
    connection-namespace: uart1
    timeout:
      minutes: 5
    method: grub
    commands: nfs
    prompts:
      - '/ # '

- test:
    namespace: debian
    timeout:
      minutes: 5
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: install-dependencies
            description: '"Install dependencies for secondary media deployment"'
            os:
              - debian
            scope:
              - functional
          run:
            steps:
              - apt-get update -q
              - apt-get install -qy bmap-tools
              - find /dev/disk
        from: inline
        name: install-dependencies
        path: inline/install-dependencies.yaml

#
# Deploy the primary board firmware bundle (this time without the additional
# network driver).
#
- deploy:
    namespace: recovery
    timeout:
      minutes: 5
    failure_retry: 2
    to: flasher
    timeout:
      minutes: 2
    images:
      recovery_image:
        url: "{{ FIRMWARE_ARTIFACT }}"
        compression: zip

- deploy:
    namespace: secondary_media
    connection-namespace: uart1
    timeout:
      minutes: 15
    to: usb
    os: oe
    images:
      image:
        url: "{{ IMAGE_ARTIFACT }}"
        compression: gz
      bmap:
        url: "{{ BMAP_ARTIFACT }}"
    uniquify: false
    device: usb_storage_device
    writer:
      tool: /usr/bin/bmaptool
      options: copy {DOWNLOAD_URL} {DEVICE}
      prompt: 'bmaptool: info'
    tool:
      prompts: ['copying time: [0-9ms\.\ ]+, copying speed [0-9\.]+ MiB\/sec']

#
# Do not verify the flash second time around as cached serial output on the
# connection will immediately match the prompt.
#

- boot:
    namespace: secondary_media
    timeout:
      minutes: 10
    method: minimal
    auto_login:
      login_prompt: 'n1sdp login:.*'
      username: cassini
      login_commands:
      - cassini123
      - cassini123
      - sudo su -
    prompts:
      - 'New password: '
      - 'Re-enter new password: '
      - '@n1sdp:.+\$ '
      - '@n1sdp:.+# '
    transfer_overlay:
      download_command: wget -S
      unpack_command: tar -C / -xzf

- test:
    namespace: secondary_media
    timeout:
{% if should_run %}
      minutes: 1030
{% else %}
      minutes: 35
{% endif %}
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: cassini-integration-tests
            description: "Run Cassini integration tests"
            os:
            - oe
            scope:
            - functional
          run:
            steps:
              - timedatectl
              - sudo systemctl restart systemd-timesyncd.service
              - timedatectl
              - lava-test-case cassini-integration-tests --shell "sudo -HEnu test ptest-runner user-accounts-integration-tests"
              - lava-test-case cassini-integration-tests --shell "sudo -HEnu test ptest-runner container-engine-integration-tests"
              - lava-test-case cassini-integration-tests --shell "sudo -HEnu test ptest-runner -t 1200 parsec-openssl-provider-tests"
{% if should_run %}
              - lava-test-case cassini-integration-tests --shell "sudo -HEnu test ptest-runner -t 3600 psa-arch-tests"
              - while true; do sleep 3600; echo "Keep Alive..."; done &
              - lava-test-case cassini-integration-tests --shell "sudo -HEnu test ptest-runner -t 36000 optee-xtests"
              - lava-test-case cassini-integration-tests --shell "sudo -HEnu test ptest-runner -t 18000 parsec-simple-e2e-tests"
{% endif %}
              - |
                if [ -e /usr/lib/k3s-integration-tests/ptest ]; then
                  lava-test-case cassini-integration-tests --shell "sudo -HEnu test ptest-runner k3s-integration-tests"
                fi
              - sudo chown -R test:test /home/test/runtime-integration-tests-logs
        from: inline
        name: cassini-integration-tests
        path: inline/cassini-integration-tests.yaml

# Upload results to artifactory
- test:
    namespace: secondary_media
    docker:
      image: {{ UTILITY_IMAGE }}
    timeout:
      minutes: 3
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: Upload-results-from-DUT
            description: "Upload results from DUT"
            os:
            - oe
            scope:
            - functional
          run:
            steps:
              - export TEST_LOGS="/home/test/runtime-integration-tests-logs"
              - mkdir -p $TEST_LOGS
              - export TARGET_IP=$(lava-target-ip)
              - scp -o "StrictHostKeyChecking no" test@$TARGET_IP:$TEST_LOGS/* $TEST_LOGS/
              - jfrog config add artifactory-aws --interactive=false --artifactory-url={{ ARTIFACTORY_AWS_URL }} --user={{ ARTIFACTORY_USER }} --password={{ ARTIFACTORY_PASS }};
              - |
                cat << EOF > ./upload_spec.json
                {
                  "files": [
                    {
                      "pattern": "${TEST_LOGS}/",
                      "target": "{{ ARTIFACTORY_NAMESPACE }}.{{ ARTIFACTORY_TMP_REPO }}/{{ CI_PROJECT_NAME }}/{{ CI_JOB_ID }}/ptest-runner-results/",
                      "flat": "true",
                      "recursive": "true"
                    }
                  ]
                }
                EOF
              - build_name="{{ ARTIFACTORY_NAMESPACE }}/{{ CI_PROJECT_PATH }}/{{ CI_JOB_NAME }}"
              - jfrog rt upload --spec=upload_spec.json --build-name="${build_name}" --build-number="{{ CI_JOB_ID }}"
              # Collect environment variables and attach them to a build.
              - jfrog rt build-collect-env "${build_name}" "{{ CI_JOB_ID }}"
              # Publish build info to Artifactory and discard old builds
              - |
                jfrog rt build-publish "${build_name}" "{{ CI_JOB_ID }}"  --build-url="{{ CI_PROJECT_URL }}" &&
                jfrog rt build-discard "${build_name}" --max-builds=10 --max-days=30 --delete-artifacts --async ||
                echo "Info: build info not supported by Artifactory"
              - cat /root/.jfrog/logs/jfrog-cli.*.log || true
        from: inline
        name: Upload-results-from-DUT
        path: inline/Upload-results-from-DUT.yaml

